%define 	pname httpd-iworx
%define		rname httpd
%define 	pversion 2.2.23
%define 	bversion 400
%define 	rpmrelease iworx

%define		iworxuser	iworx
%define		iworxgroup	iworx
%define		iworxwebuser    iworx-web
%define		iworxwebgroup   iworx-web
%define		iworxdir        /home/interworx
%define		iworxbindir     %{iworxdir}/bin
%define		iworxsysconfdir %{iworxdir}/etc
%define		iworxlibdir     %{iworxdir}/lib

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define 	build_rht_90   0
%define		build_cos_3x   0
%define		build_fdr_10   0
%define		build_fdr_20   0
%define		build_fdr_30   0
%define		build_fdr_40   0
%define		build_fdr_80   0
%define		build_fdr_90   0
%define		build_whb_3x   0
%define		build_rhe_2x   0
%define		build_rhe_3x   0
%define		build_rhe_4x   0
%define		build_rhe_5x   0
%define		build_rhe_6x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rht90:   	%{expand: %%define build_rht_90   1}}
%{?_with_cos3x: 	%{expand: %%define build_cos_3x   1}}
%{?_with_fdr10: 	%{expand: %%define build_fdr_10   1}}
%{?_with_fdr20: 	%{expand: %%define build_fdr_20   1}}
%{?_with_fdr30: 	%{expand: %%define build_fdr_30   1}}
%{?_with_fdr40: 	%{expand: %%define build_fdr_40   1}}
%{?_with_fdr80: 	%{expand: %%define build_fdr_80   1}}
%{?_with_fdr90: 	%{expand: %%define build_fdr_90   1}}
%{?_with_whb3x: 	%{expand: %%define build_whb_3x   1}}
%{?_with_rhe2x: 	%{expand: %%define build_rhe_2x   1}}
%{?_with_rhe3x: 	%{expand: %%define build_rhe_3x   1}}
%{?_with_rhe4x: 	%{expand: %%define build_rhe_4x   1}}
%{?_with_rhe5x: 	%{expand: %%define build_rhe_5x   1}}
%{?_with_rhe6x: 	%{expand: %%define build_rhe_6x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

%if %{build_rht_90}
%define		oscode rht90
%define 	ostype RedHat 9
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_cos_3x}
%define		oscode cos3x
%define 	ostype CentOS 3.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_10}
%define		oscode fdr10
%define 	ostype Fedora Core 1
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_20}
%define		oscode fdr20
%define 	ostype Fedora Core 2
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_30}
%define		oscode fdr30
%define 	ostype Fedora Core 3
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_40}
%define		oscode fdr40
%define 	ostype Fedora Core 4
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_80}
%define		oscode fdr80
%define 	ostype Fedora Core 8
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_90}
%define		oscode fdr90
%define 	ostype Fedora Core 9
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_whb_3x}
%define		oscode whb3x
%define 	ostype White Box 3.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_2x}
%define		oscode rhe2x
%define 	ostype RedHat Enterprise 2.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_3x}
%define		oscode rhe3x
%define 	ostype RedHat Enterprise 3.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_4x}
%define		oscode rhe4x
%define 	ostype RedHat Enterprise 4.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_5x}
%define		oscode rhe5x
%define 	ostype RedHat Enterprise 5.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_6x}
%define		oscode rhe6x
%define 	ostype RedHat Enterprise 6.x
BuildRequires:	pcre-devel
BuildRequires:  db4-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%define release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define 	ostype Unknown Distribution
%define 	release %{bversion}.%{rpmrelease}
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

Requires:	suphp-iworx

############### RPM ################################

Summary: 	Apache HTTP Server (InterWorx)
Name: 		%{pname}
Version: 	%{pversion}
Release: 	%{release}
License: 	Apache License, Version 2.0

Group: 		System Environment/Daemons
Source0:	%{rname}-%{version}.tar.gz
URL: 		http://httpd.apache.org/

Distribution:	InterWorx-HAL
Vendor:         INTERWORX L.L.C.
Packager:	    Paul Oehler <poehler@interworx.com>

BuildRoot:	%{_tmppath}/%{rname}-%{version}-root

Requires: 	php-iworx

BuildRequires: python

Source1:	httpd-iworx-httpd.conf
Source2:	httpd-iworx-mime.types
Source3:	httpd-iworx-iworx.conf
Source4:	httpd-iworx-httpd-custom.conf
Source5:	httpd-iworx-httpd-last.conf
Source6:	httpd-iworx-httpd-22.conf
Patch2:         httpd-2.2.22-byterange-apr_tables-inc.patch

%description
Apache is a powerful, full-featured, efficient, and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

%prep

%setup -q -n %{rname}-%{version}
%patch2 -p1

# Try detecting newest gcc (some distributions have got more then one compiler)
[ -f %{_tmppath}/%{rname}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{rname}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{rname}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{rname}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{rname}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{rname}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{rname}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{rname}-%{pversion}-gcc
fi

# Display compilation flags and OS with nice colors
[ -f %{_tmppath}/%{rname}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{rname}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{rname}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{rname}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{rname}-%{pversion}-show_flags
%{_tmppath}/%{rname}-%{pversion}-show_flags
[ -f %{_tmppath}/%{rname}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{rname}-%{pversion}-show_flags

# regenerate configure scripts
./buildconf

%build

if pkg-config openssl ; then
	# configure -C barfs with trailing spaces in CFLAGS
	CFLAGS="$RPM_OPT_FLAGS `pkg-config --cflags openssl | sed 's/ *$//'`"
	AP_LIBS="$AP_LIBS `pkg-config --libs openssl`"
else
	CFLAGS="$RPM_OPT_FLAGS"
	AP_LIBS="-lssl -lcrypto"
fi
export CFLAGS
export AP_LIBS

function mpmbuild() 
{
mpm=$1; shift
mkdir $mpm; pushd $mpm
cat > config.cache <<EOF
ac_cv_func_pthread_mutexattr_setpshared=no
ac_cv_func_sem_open=no
EOF
  ../configure 	-C \
	--prefix=%{iworxdir}/etc/httpd \
	--exec-prefix=%{iworxdir} \
 	--bindir=%{iworxdir}/bin/httpd \
 	--sbindir=%{iworxdir}/bin/httpd \
 	--mandir=/TODELETE \
	--libdir=%{iworxdir}/lib/httpd \
	--sysconfdir=%{iworxsysconfdir}/httpd/conf \
	--includedir=%{iworxdir}/include/httpd \
	--libexecdir=%{iworxlibdir}/httpd/modules \
	--with-mpm=$mpm \
        --with-devrandom=/dev/urandom \
	--with-ssl \
	--enable-ssl \
	--enable-so \
	--enable-deflate \
	$*

  %{__make} %{?_smp_mflags}
  popd
}

# Only bother enabling optional modules for main build.
mpmbuild prefork --enable-mods-shared=all

# To prevent most modules being built statically into httpd.worker, 
# easiest way seems to be enable them shared.

%install

rm -rf %{buildroot}

pushd prefork
make DESTDIR=%{buildroot} install 
popd

rm -rf %{buildroot}/TODELETE
rm -rf %{buildroot}%{iworxsysconfdir}/httpd/cgi-bin
rm -rf %{buildroot}%{iworxsysconfdir}/httpd/htdocs
rm -rf %{buildroot}%{iworxsysconfdir}/httpd/error
rm -rf %{buildroot}%{iworxsysconfdir}/httpd/icons
rm -rf %{buildroot}%{iworxsysconfdir}/httpd/logs
rm -rf %{buildroot}%{iworxsysconfdir}/httpd/manual
rm -rf %{buildroot}%{iworxsysconfdir}/httpd/conf

%if %{build_rhe_6x}
install -m0600 %{SOURCE6} %{buildroot}%{iworxsysconfdir}/httpd/httpd.conf
%else
install -m0600 %{SOURCE1} %{buildroot}%{iworxsysconfdir}/httpd/httpd.conf
%endif
install -m0600 %{SOURCE4} %{buildroot}%{iworxsysconfdir}/httpd/httpd-custom.conf
install -m0600 %{SOURCE4} %{buildroot}%{iworxsysconfdir}/httpd/httpd-custom-new.conf
install -m0600 %{SOURCE5} %{buildroot}%{iworxsysconfdir}/httpd/httpd-last.conf
install -m0600 %{SOURCE2} %{buildroot}%{iworxsysconfdir}/httpd/mime.types

mkdir -p -m0755 %{buildroot}%{_sysconfdir}/httpd/conf.d
install -m0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/httpd/conf.d/iworx.conf

%post

ln -fs %{iworxbindir}/httpd/httpd %{iworxbindir}/iworx-web

#
# only if we're upgrading
if [ "$1" = "2" ]; then
	if [ -f %{_sysconfdir}/init.d/iworx ]; then
		grep /home/interworx/etc/httpd/httpd-last.conf /home/interworx/etc/httpd/httpd-custom.conf > /dev/null
		if [ "$?" = "1" ]; then
			cp /home/interworx/etc/httpd/httpd-custom-new.conf /home/interworx/etc/httpd/httpd-custom.conf
			%{_sysconfdir}/init.d/iworx restartweb
		fi
	fi
fi

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: httpd-iworx package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi

%postun

#
# only if we're erasing
if [ "$1" = "0" ]; then
        [ -L %{iworxbindir}/iworx-web ] && rm -f %{iworxbindir}/iworx-web
fi

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%pre
# make the iworx group (if needed)
/bin/grep "^%{iworxgroup}:" /etc/group >/dev/null || groupadd -r %{iworxgroup}

# make the vchkpw group (if needed)
/bin/grep "vchkpw:" /etc/group > /dev/null || groupadd -r -g 104 vchkpw

# make the iworx  user (if needed)
/bin/grep "^%{iworxuser}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
	-g %{iworxgroup} -G vchkpw -d %{iworxdir} \
	-s /bin/bash -c %{name} -r -m %{iworxuser}


# make the iworx-web group (if needed)
/bin/grep "^%{iworxwebgroup}:" /etc/group >/dev/null || groupadd -r %{iworxwebgroup}

# make the iworx-web user (if needed)
/bin/grep "^%{iworxwebuser}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
	-g %{iworxwebgroup} -d / \
	-s /sbin/nologin -c %{name} -r %{iworxwebuser}

%files
%defattr(-,iworx,iworx)
%attr(0700,iworx,iworx) %dir %{iworxdir}/bin/httpd
%attr(0700,iworx,iworx) %{iworxdir}/bin/httpd/*
%attr(0700,iworx,iworx) %dir %{iworxsysconfdir}/httpd
%attr(0700,iworx,iworx) %{iworxsysconfdir}/*
%attr(0700,iworx,iworx) %dir %{iworxdir}/include/httpd
%attr(0600,iworx,iworx) %{iworxdir}/include/httpd/*
%attr(0700,iworx,iworx) %dir %{iworxdir}/lib/httpd
%attr(0600,iworx,iworx) %{iworxdir}/lib/httpd/*
%config(noreplace) %attr(0600,iworx,iworx) %{iworxsysconfdir}/httpd/httpd-custom.conf
%config(noreplace) %attr(0644,iworx,iworx) %{_sysconfdir}/httpd/conf.d/iworx.conf

%changelog
* Wed Oct 31 2012 Matt Parmelee <mparmelee@interworx.com>
- Updated httpd-last.conf to include phpmyadmin3.
* Tue Apr 11 2012 Paul Oehler <poehler@interworx.com>
- Upgrade to 2.2.22
* Tue Nov 02 2010 Jon Daniel <jdaniel@interworx.com>
- Removed PHPMyAdmin alias from httpd-custom
- Added PHPMyAdmin (/nodeworx and /siteworx) alias to httpd-last
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Wed Aug 11 2010 Paul Oehler <poehler@interworx.com>
- Updated httpd.conf to be 2.2 compatible
* Thu May 06 2010 Paul Oehler <poehler@interworx.com>
- Updated for RHEL 6.x
* Thu Jun 25 2009 Paul Oehler <poehler@interworx.com>
- added iworx-web user creation
* Fri May 30 2009 Paul Oehler <poehler@interworx.com>
- Added AddDefaultCharset UTF-8
* Mon May 25 2009 Paul Oehler <poehler@interworx.com>
- Added settings related to PCI complicance to default config
* Fri Jun 20 2008 Paul Oehler <poehler@interworx.com>
- Updated default httpd.conf to include mod_defate
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- bumped to 2.0.63 version, required for building with newer autotools in Fedora 8
- added support for Fedora 8
* Sat Feb 11 2005 Chris Wells <clwells@nexcess.net>
- made the install a full fledge apache install with libs / includes etc
* Tue Feb 08 2005 Chris Wells <clwells@nexcess.net>
- added squirrelmail suport to the httpd-custom.conf
- fixed awstats aliases based on new awstats package
* Sun Sep 05 2004 Chris Wells <clwells@nexcess.net>
- added AWStats support to the httpd.conf
- bumped to 2 release
* Sat Jul 03 2004 Chris Wells <clwells@nexcess.net>
- changed names of sources for consistency and added iworx.conf
* Tue Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS
